<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Task Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classTask-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Task Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Encapsulate a runnable task.  
 <a href="classTask.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Task_8h_source.html">Task.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Task:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classTask.png" usemap="#Task_map" alt=""/>
  <map id="Task_map" name="Task_map">
<area href="classHttpServerTask.html" title="Be an HTTP server task. Here we define a Task that will be run when the HTTP server starts...." alt="HttpServerTask" shape="rect" coords="0,56,116,80"/>
<area href="classPubSubClientTask.html" title="A task that will handle the PubSubClient." alt="PubSubClientTask" shape="rect" coords="126,56,242,80"/>
<area href="classWebSocketReader.html" title="A task that will watch web socket inputs." alt="WebSocketReader" shape="rect" coords="252,56,368,80"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a3db47e6fe693170a64a636ee93a1f645"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#a3db47e6fe693170a64a636ee93a1f645">Task</a> (std::string taskName=&quot;Task&quot;, uint16_t stackSize=10000, uint8_t priority=5)</td></tr>
<tr class="memdesc:a3db47e6fe693170a64a636ee93a1f645"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of the task class.  <a href="#a3db47e6fe693170a64a636ee93a1f645">More...</a><br /></td></tr>
<tr class="separator:a3db47e6fe693170a64a636ee93a1f645"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe0f5594c56b8cc7ac96c2198d5d81b4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#afe0f5594c56b8cc7ac96c2198d5d81b4">setStackSize</a> (uint16_t stackSize)</td></tr>
<tr class="memdesc:afe0f5594c56b8cc7ac96c2198d5d81b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the stack size of the task.  <a href="#afe0f5594c56b8cc7ac96c2198d5d81b4">More...</a><br /></td></tr>
<tr class="separator:afe0f5594c56b8cc7ac96c2198d5d81b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa220be4e5007ede0bd3e5349d36eae9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#aaa220be4e5007ede0bd3e5349d36eae9">setPriority</a> (uint8_t priority)</td></tr>
<tr class="memdesc:aaa220be4e5007ede0bd3e5349d36eae9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the priority of the task.  <a href="#aaa220be4e5007ede0bd3e5349d36eae9">More...</a><br /></td></tr>
<tr class="separator:aaa220be4e5007ede0bd3e5349d36eae9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23abd79183a5c2bb1e6d3ff37b1cbf23"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#a23abd79183a5c2bb1e6d3ff37b1cbf23">setName</a> (std::string name)</td></tr>
<tr class="memdesc:a23abd79183a5c2bb1e6d3ff37b1cbf23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of the task.  <a href="#a23abd79183a5c2bb1e6d3ff37b1cbf23">More...</a><br /></td></tr>
<tr class="separator:a23abd79183a5c2bb1e6d3ff37b1cbf23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ec932fb35fd295c78eafcf06af1d91d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#a5ec932fb35fd295c78eafcf06af1d91d">setCore</a> (BaseType_t coreId)</td></tr>
<tr class="memdesc:a5ec932fb35fd295c78eafcf06af1d91d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the core number the task has to be executed on. If the core number is not set, tskNO_AFFINITY will be used.  <a href="#a5ec932fb35fd295c78eafcf06af1d91d">More...</a><br /></td></tr>
<tr class="separator:a5ec932fb35fd295c78eafcf06af1d91d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f13d13787e21dc929b61d112b863433"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#a6f13d13787e21dc929b61d112b863433">start</a> (void *taskData=nullptr)</td></tr>
<tr class="memdesc:a6f13d13787e21dc929b61d112b863433"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start an instance of the task.  <a href="#a6f13d13787e21dc929b61d112b863433">More...</a><br /></td></tr>
<tr class="separator:a6f13d13787e21dc929b61d112b863433"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba5eb3d6c2a034aa0e319383fbec68c4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#aba5eb3d6c2a034aa0e319383fbec68c4">stop</a> ()</td></tr>
<tr class="memdesc:aba5eb3d6c2a034aa0e319383fbec68c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop the task.  <a href="#aba5eb3d6c2a034aa0e319383fbec68c4">More...</a><br /></td></tr>
<tr class="separator:aba5eb3d6c2a034aa0e319383fbec68c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a399f60ad8cd91d34dba2de57b4ac6d65"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#a399f60ad8cd91d34dba2de57b4ac6d65">run</a> (void *data)=0</td></tr>
<tr class="memdesc:a399f60ad8cd91d34dba2de57b4ac6d65"><td class="mdescLeft">&#160;</td><td class="mdescRight">Body of the task to execute.  <a href="#a399f60ad8cd91d34dba2de57b4ac6d65">More...</a><br /></td></tr>
<tr class="separator:a399f60ad8cd91d34dba2de57b4ac6d65"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aa4b603c866f4b8e0f0c6b524bb0e287e"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTask.html#aa4b603c866f4b8e0f0c6b524bb0e287e">delay</a> (int ms)</td></tr>
<tr class="memdesc:aa4b603c866f4b8e0f0c6b524bb0e287e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suspend the task for the specified milliseconds.  <a href="#aa4b603c866f4b8e0f0c6b524bb0e287e">More...</a><br /></td></tr>
<tr class="separator:aa4b603c866f4b8e0f0c6b524bb0e287e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Encapsulate a runnable task. </p>
<p>This class is designed to be subclassed with the method:</p>
<div class="fragment"><div class="line"><span class="keywordtype">void</span> <a class="code" href="classTask.html#a399f60ad8cd91d34dba2de57b4ac6d65">run</a>(<span class="keywordtype">void</span> *data) { ... }</div></div><!-- fragment --><p>For example:</p>
<div class="fragment"><div class="line"><span class="keyword">class </span>CurlTestTask : <span class="keyword">public</span> <a class="code" href="classTask.html">Task</a> {</div><div class="line">   <span class="keywordtype">void</span> <a class="code" href="classTask.html#a399f60ad8cd91d34dba2de57b4ac6d65">run</a>(<span class="keywordtype">void</span> *data) {</div><div class="line">      <span class="comment">// Do something</span></div><div class="line">   }</div><div class="line">};</div></div><!-- fragment --><p>implemented. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a3db47e6fe693170a64a636ee93a1f645"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3db47e6fe693170a64a636ee93a1f645">&#9670;&nbsp;</a></span>Task()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Task::Task </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>taskName</em> = <code>&quot;Task&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>stackSize</em> = <code>10000</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>priority</em> = <code>5</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create an instance of the task class. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">taskName</td><td>The name of the task to create. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">stackSize</td><td>The size of the stack. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa4b603c866f4b8e0f0c6b524bb0e287e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4b603c866f4b8e0f0c6b524bb0e287e">&#9670;&nbsp;</a></span>delay()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Task::delay </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Suspend the task for the specified milliseconds. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ms</td><td>The delay time in milliseconds. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a399f60ad8cd91d34dba2de57b4ac6d65"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a399f60ad8cd91d34dba2de57b4ac6d65">&#9670;&nbsp;</a></span>run()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Task::run </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Body of the task to execute. </p>
<p>This function must be implemented in the subclass that represents the actual task to run. When a task is started by calling <a class="el" href="classTask.html#a6f13d13787e21dc929b61d112b863433" title="Start an instance of the task.">start()</a>, this is the code that is executed in the newly created task.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>The data passed in to the newly started task. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5ec932fb35fd295c78eafcf06af1d91d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5ec932fb35fd295c78eafcf06af1d91d">&#9670;&nbsp;</a></span>setCore()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::setCore </td>
          <td>(</td>
          <td class="paramtype">BaseType_t&#160;</td>
          <td class="paramname"><em>coreId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the core number the task has to be executed on. If the core number is not set, tskNO_AFFINITY will be used. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">coreId</td><td>The id of the core. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a23abd79183a5c2bb1e6d3ff37b1cbf23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a23abd79183a5c2bb1e6d3ff37b1cbf23">&#9670;&nbsp;</a></span>setName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::setName </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the name of the task. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">name</td><td>The name for the task. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="aaa220be4e5007ede0bd3e5349d36eae9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa220be4e5007ede0bd3e5349d36eae9">&#9670;&nbsp;</a></span>setPriority()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::setPriority </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>priority</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the priority of the task. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">priority</td><td>The priority for the task. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="afe0f5594c56b8cc7ac96c2198d5d81b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe0f5594c56b8cc7ac96c2198d5d81b4">&#9670;&nbsp;</a></span>setStackSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::setStackSize </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>stackSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the stack size of the task. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">stackSize</td><td>The size of the stack for the task. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a6f13d13787e21dc929b61d112b863433"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f13d13787e21dc929b61d112b863433">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::start </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>taskData</em> = <code>nullptr</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start an instance of the task. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">taskData</td><td>Data to be passed into the task. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="aba5eb3d6c2a034aa0e319383fbec68c4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba5eb3d6c2a034aa0e319383fbec68c4">&#9670;&nbsp;</a></span>stop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Task::stop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Stop the task. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="Task_8h_source.html">Task.h</a></li>
<li>Task.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
